"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TssCacheProvider = exports.useTssEmotionCache = exports.getTssDefaultEmotionCache = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var cache_1 = __importDefault(require("@emotion/cache"));
exports.getTssDefaultEmotionCache = (function () {
    var cache = undefined;
    /** Lazily initialized singleton */
    function getTssDefaultEmotionCache() {
        if (cache === undefined) {
            cache = (0, cache_1.default)({ "key": "tss-react" });
        }
        return cache;
    }
    return { getTssDefaultEmotionCache: getTssDefaultEmotionCache };
})().getTssDefaultEmotionCache;
var context = (0, react_1.createContext)(undefined);
function useTssEmotionCache() {
    var cacheExplicitlyProvidedForTss = (0, react_1.useContext)(context);
    return cacheExplicitlyProvidedForTss !== null && cacheExplicitlyProvidedForTss !== void 0 ? cacheExplicitlyProvidedForTss : (0, exports.getTssDefaultEmotionCache)();
}
exports.useTssEmotionCache = useTssEmotionCache;
function TssCacheProvider(props) {
    var children = props.children, value = props.value;
    return (0, jsx_runtime_1.jsx)(context.Provider, __assign({ value: value }, { children: children }), void 0);
}
exports.TssCacheProvider = TssCacheProvider;
//# sourceMappingURL=cache.js.map