"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMakeStyles = void 0;
var Object_fromEntries_1 = require("./tools/Object.fromEntries");
var objectKeys_1 = require("./tools/objectKeys");
var cssAndCx_1 = require("./cssAndCx");
/**
 * @see {@link https://github.com/garronej/tss-react}
 */
function createMakeStyles(params) {
    var useTheme = params.useTheme;
    /** returns useStyle. */
    function makeStyles() {
        return function (getCssObjectOrCssObject) {
            var getCssObject = typeof getCssObjectOrCssObject === "function"
                ? getCssObjectOrCssObject
                : function () { return getCssObjectOrCssObject; };
            function useStyles(params) {
                var theme = useTheme();
                var _a = (0, cssAndCx_1.useCssAndCx)(), cx = _a.cx, css = _a.css;
                var count = 0;
                function createRef() {
                    return "tss-react-ref_" + count++;
                }
                var cssObject = getCssObject(theme, params, createRef);
                var classes = (0, Object_fromEntries_1.fromEntries)((0, objectKeys_1.objectKeys)(cssObject).map(function (key) { return [
                    key,
                    css(cssObject[key]),
                ]; }));
                return {
                    classes: classes,
                    theme: theme,
                    css: css,
                    cx: cx,
                };
            }
            return useStyles;
        };
    }
    function useStyles() {
        var theme = useTheme();
        var _a = (0, cssAndCx_1.useCssAndCx)(), css = _a.css, cx = _a.cx;
        return { theme: theme, css: css, cx: cx };
    }
    return { makeStyles: makeStyles, useStyles: useStyles };
}
exports.createMakeStyles = createMakeStyles;
//# sourceMappingURL=createMakeStyles.js.map