"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCssAndCx = exports.cssAndCxFactory = void 0;
var classnames_1 = require("./tools/classnames");
var serialize_1 = require("@emotion/serialize");
var utils_1 = require("@emotion/utils");
var useGuaranteedMemo_1 = require("./tools/useGuaranteedMemo");
var cache_1 = require("./cache");
var refPropertyName = "ref";
exports.cssAndCxFactory = (function () {
    function merge(registered, css, className) {
        var registeredStyles = [];
        var rawClassName = (0, utils_1.getRegisteredStyles)(registered, registeredStyles, className);
        if (registeredStyles.length < 2) {
            return className;
        }
        return rawClassName + css(registeredStyles);
    }
    function cssAndCxFactory(params) {
        var cache = params.cache;
        var css = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var ref = undefined;
            scope: {
                if (args.length !== 1) {
                    break scope;
                }
                var _a = __read(args, 1), arg = _a[0];
                if (!(arg instanceof Object)) {
                    break scope;
                }
                if (!(refPropertyName in arg)) {
                    break scope;
                }
                ref = arg[refPropertyName];
                var argCopy = __assign({}, arg);
                delete argCopy[refPropertyName];
                args = [argCopy];
            }
            var serialized = (0, serialize_1.serializeStyles)(args, cache.registered);
            (0, utils_1.insertStyles)(cache, serialized, false);
            return cache.key + "-" + serialized.name + (ref === undefined ? "" : " " + ref);
        };
        var cx = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return merge(cache.registered, css, (0, classnames_1.classnames)(args));
        };
        return { css: css, cx: cx };
    }
    return { cssAndCxFactory: cssAndCxFactory };
})().cssAndCxFactory;
/** Will pickup the contextual cache if any */
function useCssAndCx() {
    var cache = (0, cache_1.useTssEmotionCache)();
    var _a = (0, useGuaranteedMemo_1.useGuaranteedMemo)(function () { return (0, exports.cssAndCxFactory)({ cache: cache }); }, [cache]), css = _a.css, cx = _a.cx;
    return { css: css, cx: cx };
}
exports.useCssAndCx = useCssAndCx;
//# sourceMappingURL=cssAndCx.js.map